## schroot 1.6.13

=== CMakeLists.txt ===
# Copyright © 2004-2013  Roger Leigh <rleigh@codelibre.net>
#
# schroot is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation, either version 3 of the License, or (at your
# option) any later version.
#
# schroot is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

cmake_minimum_required(VERSION 2.8.12)
cmake_policy(VERSION 2.8.12)

project(schroot)

if("${PROJECT_SOURCE_DIR}" STREQUAL "${PROJECT_BINARY_DIR}")
  message(FATAL_ERROR "In-tree builds are not supported; please run cmake from a separate build directory.")
endif("${PROJECT_SOURCE_DIR}" STREQUAL "${PROJECT_BINARY_DIR}")

# Obtain version information from VERSION and/or git.
set(GIT_VERSION_FILE "cmake/GitVersion.cmake"
    CACHE FILEPATH "Location of version metadata")
set(GIT_VERSION_FILE_COMPAT "VERSION"
    CACHE FILEPATH "Location of compatibility version metadata")
set(GIT_VERSION_FILE_USE_COMPAT ON
    CACHE BOOL "Use compatibility version file")
set(GIT_RELEASE_POLICY_FILE "${PROJECT_SOURCE_DIR}/cmake/GitReleasePolicy.cmake"
    CACHE FILEPATH "Location of release policy configuration")
include("${PROJECT_SOURCE_DIR}/cmake/GitRelease.cmake")

set(VERSION ${GIT_RELEASE_VERSION})
set(RELEASE_DATE ${GIT_RELEASE_DATE_UNIX})
set(RELEASE_DATE_S ${GIT_RELEASE_DATE})

string(REGEX MATCH "^([0-9]+-[0-9]+-[0-9]+).*" date_valid "${RELEASE_DATE_S}")
if (date_valid)
  string(REGEX REPLACE "^([0-9]+-[0-9]+-[0-9]+).*" "\\1"
         RELEASE_DATE_SHORT ${RELEASE_DATE_S})
else (date_valid)
  set(RELEASE_DATE_SHORT ${RELEASE_DATE_S})
endif (date_valid)

message(STATUS "Configuring ${CMAKE_PROJECT_NAME} ${GIT_RELEASE_VERSION} (${RELEASE_DATE_SHORT})")

# TODO: Check NEWS version

include(GNUInstallDirs)
include(CheckIncludeFileCXX)
include(CheckCXXCompilerFlag)
include(CheckCXXSourceCompiles)
include("cmake/CompilerChecks.cmake")

find_package(Threads REQUIRED)

include(FindBoost)
find_package(Boost REQUIRED
             COMPONENTS filesystem system iostreams program_options regex)

# HEADER CHECKS
include(CheckIncludeFileCXX)

# LIBRARY CHECKS
include (CheckLibraryExists)
include (CheckFunctionExists)

include("cmake/boost-checks.cmake")
include("cmake/regex-checks.cmake")

# Configure dchroot and dchroot-dsa
option(dchroot "Enable dchroot compatibility" OFF)
option(dchroot-dsa "Enable dchroot-dsa compatibility" OFF)
set(BUILD_DCHROOT 0)
set(BUILD_DCHROOT_DSA 0)
set(BUILD_LIBDCHROOT 0)
if(dchroot)
  set(BUILD_LIBDCHROOT 1)
  set(BUILD_DCHROOT 1)
endif(dchroot)
if(dchroot-dsa)
  set(BUILD_LIBDCHROOT 1)
  set(BUILD_DCHROOT_DSA 1)
endif(dchroot-dsa)

# Configure debugging
option(debug "Enable debugging messages" OFF)
set(SBUILD_DEBUG 0)
if(debug)
  set(SBUILD_DEBUG 1)
endif(debug)

# Configure testing
SET(CMAKE_REQUIRED_LIBRARIES_SAVE ${CMAKE_REQUIRED_LIBRARIES})
SET(CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES} cppunit)
check_cxx_source_compiles(
"#include <cppunit/ui/text/TestRunner.h>

int main() {
  CppUnit::TextUi::TestRunner runner;
}"
CPPUNIT_CLASS)
SET(CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES_SAVE})
set(BUILD_TESTS OFF)
if(CPPUNIT_CLASS)
  set(BUILD_TESTS ON)
endif(CPPUNIT_CLASS)
option(test "Enable unit tests" ${BUILD_TESTS})
set(BUILD_TESTS ${test})
if(BUILD_TESTS)
  set(CPPUNIT_LIBRARY cppunit)
endif(BUILD_TESTS)

# Environment filter default
set(default_environment_filter "^(BASH_ENV|CDPATH|ENV|HOSTALIASES|IFS|KRB5_CONFIG|KRBCONFDIR|KRBTKFILE|KRB_CONF|LD_.*|LOCALDOMAIN|NLSPATH|PATH_LOCALE|RES_OPTIONS|TERMINFO|TERMINFO_DIRS|TERMPATH)\$"
    CACHE STRING "Default environment filter")
set(SBUILD_DEFAULT_ENVIRONMENT_FILTER ${default_environment_filter})

# bash completion directory
set(bash_completion_dir "${CMAKE_INSTALL_SYSCONFDIR}/bash_completion.d"
    CACHE PATH "bash shell completion directory")
#==> bashcompletiondir (use cache val directly)

# schroot directories
set(SCHROOT_LOCALE_DIR "${CMAKE_INSTALL_FULL_LOCALEDIR}"
    CACHE PATH "Locale directory")
set(SCHROOT_MOUNT_DIR "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/run/${CMAKE_PROJECT_NAME}/mount"
    CACHE PATH "Directory under which mount chroots")
set(SCHROOT_SESSION_DIR "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/lib/${CMAKE_PROJECT_NAME}/session"
    CACHE PATH "Directory for storing session metadata")
set(SCHROOT_FILE_UNPACK_DIR "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/lib/${CMAKE_PROJECT_NAME}/unpack"
    CACHE PATH "Directory for unpacking chroot file archives under")
set(SCHROOT_OVERLAY_DIR "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/lib/${CMAKE_PROJECT_NAME}/union/overlay"
    CACHE PATH "Directory for union filesystem writable overlays")
set(SCHROOT_UNDERLAY_DIR "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/lib/${CMAKE_PROJECT_NAME}/union/underlay"
    CACHE PATH "Directory for union filesystem read-only underlays")
set(SCHROOT_MODULE_DIR "${CMAKE_INSTALL_FULL_LIBDIR}/${CMAKE_PROJECT_NAME}/${GIT_RELEASE_VERSION}/modules"
    CACHE PATH "Directory for loadable modules")
set(SCHROOT_DATA_DIR "${CMAKE_INSTALL_FULL_DATADIR}/${CMAKE_PROJECT_NAME}"
    CACHE PATH "Directory for schroot data files")
set(SCHROOT_LIBEXEC_DIR "${CMAKE_INSTALL_FULL_LIBEXECDIR}/${CMAKE_PROJECT_NAME}"
    CACHE PATH "Directory for schroot helper programs")
set(SCHROOT_SYSCONF_DIR "${CMAKE_INSTALL_FULL_SYSCONFDIR}/${CMAKE_PROJECT_NAME}"
    CACHE PATH "Directory for configuration files")
set(SCHROOT_CONF_CHROOT_D "${SCHROOT_SYSCONF_DIR}/chroot.d"
    CACHE PATH "Directory for chroot configuration fragments")
set(SCHROOT_CONF_SETUP_D "${SCHROOT_SYSCONF_DIR}/setup.d"
    CACHE PATH "Directory for chroot setup scripts")
set(SCHROOT_SETUP_DATA_DIR "${CMAKE_INSTALL_FULL_DATADIR}/${CMAKE_PROJECT_NAME}/setup"
    CACHE PATH "Directory for common setup script data")
mark_as_advanced(SCHROOT_LOCALE_DIR SCHROOT_MOUNT_DIR
                 SCHROOT_SESSION_DIR SCHROOT_FILE_UNPACK_DIR
                 SCHROOT_OVERLAY_DIR SCHROOT_UNDERLAY_DIR
                 SCHROOT_MODULE_DIR SCHROOT_DATA_DIR
                 SCHROOT_LIBEXEC_DIR SCHROOT_SYSCONF_DIR
                 SCHROOT_CONF_CHROOT_D SCHROOT_CONF_SETUP_D
                 SCHROOT_SETUP_DATA_DIR)

set(TESTDATADIR "${PROJECT_BINARY_DIR}/test/testdata")

# schroot files
set(SCHROOT_CONF "${SCHROOT_SYSCONF_DIR}/schroot.conf")

# Platform
string(TOLOWER ${CMAKE_SYSTEM_NAME} SBUILD_PLATFORM)

# Localisation with gettext
include(FindGettext)
find_package(Gettext)
set(NLS_DEFAULT OFF)
if(GETTEXT_FOUND)
  set(NLS_DEFAULT ON)
endif(GETTEXT_FOUND)
option(nls "Enable national language support (requires gettext)" ${NLS_DEFAULT})
set(BUILD_NLS ${nls})
set(SBUILD_FEATURE_NLS ${pam})

# UUID generation
check_include_file_cxx(uuid/uuid.h UUID_HEADER)
check_library_exists(uuid uuid_generate "" UUID_FUNC)
set(UUID_DEFAULT OFF)
if(UUID_HEADER AND UUID_FUNC)
  set(UUID_DEFAULT ON)
endif(UUID_HEADER AND UUID_FUNC)
option(uuid "Enable support for UUIDs in session names (requires libuuid)" ${UUID_DEFAULT})
set(BUILD_UUID ${uuid})
set(SBUILD_USE_UUID ${uuid})
if(BUILD_UUID)
  set(UUID_LIBRARY uuid)
endif(BUILD_UUID)

# PAM authentication feature
check_include_file_cxx (security/pam_appl.h PAM_HEADER)
check_library_exists(pam pam_authenticate "" PAM_FUNC)
set(PAM_DEFAULT OFF)
if(PAM_HEADER AND PAM_FUNC)
  set(PAM_DEFAULT ON)
endif(PAM_HEADER AND PAM_FUNC)
option(pam "Enable support for PAM authentication (requires libpam)" ${PAM_DEFAULT})
set(BUILD_PAM ${pam})
set(SBUILD_FEATURE_PAM ${pam})
if(BUILD_PAM)
  set(PAM_LIBRARY pam)
endif(BUILD_PAM)

# Set early, so it can be overridden by lvm-snapshot and block-device
set(BLOCKDEV_DEFAULT ON)

# LVM snapshot mount feature
find_program(LVCREATE_EXECUTABLE lvcreate PATHS /sbin /usr/sbin /usr/local/sbin)
find_program(LVREMOVE_EXECUTABLE lvremove PATHS /sbin /usr/sbin /usr/local/sbin)
set(LVMSNAP_DEFAULT OFF)
if (LVCREATE_EXECUTABLE AND LVREMOVE_EXECUTABLE)
  set (LVMSNAP_DEFAULT ON)
endif (LVCREATE_EXECUTABLE AND LVREMOVE_EXECUTABLE)
option(lvm-snapshot "Enable support for LVM snapshots (requires LVM)" ${LVMSNAP_DEFAULT})
set(BUILD_LVMSNAP ${lvm-snapshot})
set(SBUILD_FEATURE_LVMSNAP ${lvm-snapshot})
if (lvm-snapshot)
  set(BLOCKDEV_DEFAULT ON)
endif(lvm-snapshot)

# ZFS snapshot mount feature
find_program(ZFS_EXECUTABLE zfs PATHS /sbin /usr/sbin /usr/local/sbin)
set(ZFSSNAP_DEFAULT OFF)
if (ZFS_EXECUTABLE)
  set (ZFSSNAP_DEFAULT ON)
endif (ZFS_EXECUTABLE)
option(zfs-snapshot "Enable support for ZFS snapshots (requires ZFS)" ${ZFSSNAP_DEFAULT})
set(BUILD_ZFSSNAP ${zfs-snapshot})
set(SBUILD_FEATURE_ZFSSNAP ${zfs-snapshot})
if (zfs-snapshot)
  set(BLOCKDEV_DEFAULT ON)
endif(zfs-snapshot)

# Btrfs snapshot mount feature
find_program(BTRFS_EXECUTABLE btrfs PATHS /sbin /usr/sbin /usr/local/sbin)
set(BTRFSSNAP_DEFAULT OFF)
if (BTRFS_EXECUTABLE)
  set (BTRFSSNAP_DEFAULT ON)
endif (BTRFS_EXECUTABLE)
option(btrfs-snapshot "Enable support for btrfs snapshots (requires Btrfs)" ${BTRFSSNAP_DEFAULT})
set(BUILD_BTRFSSNAP ${btrfs-snapshot})
set(SBUILD_FEATURE_BTRFSSNAP ${btrfs-snapshot})
if (btrfs-snapshot)
  set(BLOCKDEV_DEFAULT ON)
endif(btrfs-snapshot)

# Block device mount feature
option(block-device "Enable support for block devices" ${BLOCKDEV_DEFAULT})
set(BUILD_BLOCKDEV ${block-device})
set(SBUILD_FEATURE_BLOCKDEV ${block-device})
# Check for blockdev/lvmsnap option compatibility
if(lvm-snapshot AND NOT block-device)
  message(FATAL_ERROR "block-device must be enabled when lvm-snapshot is enabled")
endif(lvm-snapshot AND NOT block-device)
if(zfs-snapshot AND NOT block-device)
  message(FATAL_ERROR "block-device must be enabled when zfs-snapshot is enabled")
endif(zfs-snapshot AND NOT block-device)
if(btrfs-snapshot AND NOT block-device)
  message(FATAL_ERROR "block-device must be enabled when btrfs-snapshot is enabled")
endif(btrfs-snapshot AND NOT block-device)

# Loopback mount feature
find_program(LOSETUP_EXECUTABLE losetup PATHS /sbin /usr/sbin /usr/local/sbin)
set(LOOPBACK_DEFAULT OFF)
if (LOSETUP_EXECUTABLE)
  set (LOOPBACK_DEFAULT ON)
endif (LOSETUP_EXECUTABLE)
option(loopback "Enable support for loopback mounts" ${LOOPBACK_DEFAULT})
set(BUILD_LOOPBACK ${loopback})
set(SBUILD_FEATURE_LOOPBACK ${loopback})

# Filesystem union mount feature
set(UNION_DEFAULT ON)
option(union "Enable support for union mounts" ${UNION_DEFAULT})
set(BUILD_UNION ${union})
set(SBUILD_FEATURE_UNION ${union})

# Doxygen documentation
include(FindDoxygen)
find_package(Doxygen)
set(DOXYGEN_DEFAULT OFF)
if (DOXYGEN_EXECUTABLE)
  set (DOXYGEN_DEFAULT ON)
endif (DOXYGEN_EXECUTABLE)
option(doxygen "Enable doxygen documentation" ${DOXYGEN_DEFAULT})
set(BUILD_DOXYGEN ${doxygen})

# Kernel personality feature
# sys/personality.h ==> PERSONALITY_HEADER
check_include_file_cxx (sys/personality.h PERSONALITY_HEADER)
check_function_exists(personality PERSONALITY_FUNC)
set(PERSONALITY_DEFAULT OFF)
if (PERSONALITY_HEADER AND PERSONALITY_FUNC)
  set (PERSONALITY_DEFAULT ON)
endif (PERSONALITY_HEADER AND PERSONALITY_FUNC)
option(personality "Enable personality support (Linux only)" ${PERSONALITY_DEFAULT})
set(BUILD_PERSONALITY ${personality})
set(SBUILD_FEATURE_PERSONALITY ${personality})

# GENERATED FILES:
configure_file(${PROJECT_SOURCE_DIR}/config.h.cmake ${PROJECT_BINARY_DIR}/config.h)

include_directories(${PROJECT_BINARY_DIR}/lib
                    ${PROJECT_SOURCE_DIR}/lib
                    ${PROJECT_BINARY_DIR}
                    ${PROJECT_SOURCE_DIR})

enable_testing()

add_subdirectory(sbuild)
add_subdirectory(bin)
add_subdirectory(test)
add_subdirectory(doc)
add_subdirectory(etc)
add_subdirectory(po)
add_subdirectory(man)

add_custom_target(check-news

=== bin/CMakeLists.txt ===
# Copyright © 2004-2013  Roger Leigh <rleigh@codelibre.net>
#
# schroot is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# schroot is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see
# <http://www.gnu.org/licenses/>.
#
#####################################################################

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

add_subdirectory(dchroot)
add_subdirectory(dchroot-dsa)
add_subdirectory(schroot)
add_subdirectory(schroot-base)
add_subdirectory(schroot-listmounts)
add_subdirectory(schroot-mount)

=== doc/CMakeLists.txt ===
# Copyright © 2004-2013  Roger Leigh <rleigh@codelibre.net>
#
# schroot is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# schroot is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see
# <http://www.gnu.org/licenses/>.
#
#####################################################################

if(BUILD_DOXYGEN)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/sbuild.dox.cmake
                 ${CMAKE_CURRENT_BINARY_DIR}/sbuild.dox @ONLY)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/schroot.dox.cmake
                 ${CMAKE_CURRENT_BINARY_DIR}/schroot.dox @ONLY)

  add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/sbuild.log
                     COMMAND ${CMAKE_COMMAND} -E remove_directory sbuild
                     COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/sbuild.dox
                     COMMAND ${CMAKE_COMMAND} -E echo "══════════ UNDOCUMENTED CODE ══════════"
                     COMMAND cat ${CMAKE_CURRENT_BINARY_DIR}/sbuild.log
                     COMMAND ${CMAKE_COMMAND} -E echo "═════════ END UNDOCUMENTED CODE ═══════"
                     DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/sbuild.dox)

  add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/schroot.log
                     COMMAND ${CMAKE_COMMAND} -E remove_directory schroot
                     COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/schroot.dox
                     COMMAND ${CMAKE_COMMAND} -E echo "══════════ UNDOCUMENTED CODE ══════════"
                     COMMAND cat ${CMAKE_CURRENT_BINARY_DIR}/schroot.log
                     COMMAND ${CMAKE_COMMAND} -E echo "═════════ END UNDOCUMENTED CODE ═══════"
                     DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/schroot.dox)

  add_custom_target(doc DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/sbuild.log ${CMAKE_CURRENT_BINARY_DIR}/schroot.log)
endif(BUILD_DOXYGEN)

=== etc/CMakeLists.txt ===
# Copyright © 2004-2013  Roger Leigh <rleigh@codelibre.net>
#
# schroot is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# schroot is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see
# <http://www.gnu.org/licenses/>.
#
#####################################################################

set(schroot_sysconf_data
    schroot.conf)

install(FILES ${schroot_sysconf_data}
        DESTINATION ${SCHROOT_SYSCONF_DIR})

set(files
    copyfiles
    fstab
    nssdatabases)

set(profiles
    buildd
    default
    desktop
    minimal
    sbuild)

set(arches
    ${SBUILD_PLATFORM})

foreach(profile ${profiles})
  foreach(file ${files})
    file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/profiles/${profile}")
    set(output_file "${CMAKE_CURRENT_BINARY_DIR}/profiles/${profile}/${file}")
    foreach(arch ${arches})
      if(EXISTS ${output_file})
        file(REMOVE ${output_file})
      endif(EXISTS ${output_file})
      foreach(source_file
        ${CMAKE_CURRENT_SOURCE_DIR}/profile-templates/all/all/${file}
        ${CMAKE_CURRENT_SOURCE_DIR}/profile-templates/all/${arch}/${file}
        ${CMAKE_CURRENT_SOURCE_DIR}/profile-templates/${profile}/all/${file}
        ${CMAKE_CURRENT_SOURCE_DIR}/profile-templates/${profile}/${arch}/${file})
        if(EXISTS ${source_file})
          file(READ ${source_file} content)
          if(EXISTS ${source_file})
            file(APPEND ${output_file} ${content})
          else(EXISTS ${source_file})
            file(WRITE ${output_file} ${content})
          endif(EXISTS ${source_file})
        endif(EXISTS ${source_file})
      endforeach(source_file)
      if(EXISTS ${output_file})
        message(STATUS "Generated schroot profile ${profile}/${file}")
        install(FILES ${output_file}
                DESTINATION ${SCHROOT_SYSCONF_DIR}/${profile})
      endif(EXISTS ${output_file})
    endforeach(arch)
  endforeach(file)
endforeach(profile)

add_subdirectory(pam)
add_subdirectory(bash_completion)
add_subdirectory(setup.d)

=== man/CMakeLists.txt ===
# Copyright © 2004-2013  Roger Leigh <rleigh@codelibre.net>
#
# schroot is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# schroot is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see
# <http://www.gnu.org/licenses/>.
#
#####################################################################

find_program(PO4A_EXECUTABLE po4a)
find_program(GROFFER_EXECUTABLE groffer)
find_program(SOELIM_EXECUTABLE soelim)

# generate config.man
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.man.cmake
               ${CMAKE_CURRENT_BINARY_DIR}/config.man)

set(common_dependencies
    authors.man
    copyright.man)

set(manpage_sources
    dchroot.1.man
    dchroot-dsa.1.man
    schroot.1.man
    schroot-setup.5.man
    schroot.conf.5.man
    schroot-script-config.5.man
    schroot-faq.7.man)

# Translated manual pages

file(READ po/LINGUAS languages)
STRING(REGEX REPLACE "\n" ";" languages "${languages}")
foreach(lang ${languages})
  if (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/po/${lang}.po")
    set(po_sources ${po_sources} "${CMAKE_CURRENT_SOURCE_DIR}/po/${lang}.po")
  endif (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/po/${lang}.po")
endforeach(lang)

set(po4a_command
    ${PO4A_EXECUTABLE} --package-name ${CMAKE_PROJECT_NAME}
    --package-version ${GIT_RELEASE_VERSION}
    --copyright-holder "Roger Leigh <rleigh@codelibre.net>"
    "--srcdir=${CMAKE_CURRENT_SOURCE_DIR}"
    "--destdir=${CMAKE_CURRENT_BINARY_DIR}"
    "${CMAKE_CURRENT_SOURCE_DIR}/po4a.cfg")

if(PO4A_EXECUTABLE)
  # We need to run po4a initially to see what it generates, prior to
  # generating the rule to autogenerate from source.
  execute_process(COMMAND ${po4a_command})

  file(GLOB translated_dirs RELATIVE
       ${CMAKE_CURRENT_BINARY_DIR}/translated
       ${CMAKE_CURRENT_BINARY_DIR}/translated/*)
  foreach(lang ${translated_dirs})
    if(IS_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/translated/${lang}")
      set(languages {languages} ${lang})
      file(GLOB translated_files
           ${CMAKE_CURRENT_BINARY_DIR}/translated/${lang}/*.man)
        set(translated_manpage_sources
            ${translated_manpage_sources}
            ${translated_files})
    endif(IS_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/translated/${lang}")
  endforeach(lang)

  add_custom_command(OUTPUT ${translated_manpage_sources}
                     COMMAND ${po4a_command}
                     DEPENDS ${common_dependencies} ${manpage_sources}
                             ${po_sources}
                             "${CMAKE_CURRENT_SOURCE_DIR}/po4a.cfg"
                     VERBATIM)
else(PO4A_EXECUTABLE)
  warn("po4a not available; not translating manual pages")
endif(PO4A_EXECUTABLE)

set(manpage_sources
    ${manpage_sources}
    ${translated_manpage_sources})

add_custom_target(manpage-sources ALL DEPENDS ${manpage_sources})
if(GIT_RELEASE_ENABLE)
  add_dependencies(git-release manpage-sources)
endif(GIT_RELEASE_ENABLE)

foreach(manpage_source ${manpage_sources})
  unset(lang)
  unset(pagename)
  unset(section)
  string(REGEX MATCH ".*/translated/([^/]+)/(.+)\\.([0-9])\\.man\$" is_translation ${manpage_source})
  if(is_translation)
    string(REGEX REPLACE ".*/translated/([^/]+)/(.+)\\.([0-9])\\.man\$" "\\1;\\2;\\3" translation_matches ${manpage_source})
    list(GET translation_matches 0 lang)
    list(GET translation_matches 1 pagename)
    list(GET translation_matches 2 section)
      set(manpage_source_file ${manpage_source})
  else(is_translation)
    string(REGEX MATCH "^(.+)\\.([0-9])\\.man\$" is_manpage ${manpage_source})
    if (is_manpage)
      string(REGEX REPLACE "^(.+)\\.([0-9])\\.man\$" "\\1;\\2" manpage_matches ${manpage_source})
      unset(lang)
      list(GET manpage_matches 0 pagename)
      list(GET manpage_matches 1 section)
      set(manpage_source_file "${CMAKE_CURRENT_SOURCE_DIR}/${manpage_source}")
    endif (is_manpage)
  endif(is_translation)

  if(pagename AND NOT BUILD_DCHROOT)
    string(REGEX MATCH "^dchroot\$" dchroot_match ${pagename})
    if (dchroot_match)
      unset(pagename)
    endif (dchroot_match)
  endif(pagename AND NOT BUILD_DCHROOT)
  if(pagename AND NOT BUILD_DCHROOT_DSA)
    string(REGEX MATCH "^dchroot-dsa\$" dchroot_dsa_match ${pagename})
    if (dchroot_dsa_match)
      unset(pagename)
    endif (dchroot_dsa_match)
  endif(pagename AND NOT BUILD_DCHROOT_DSA)

  if(pagename)
    # Filter out manpages which should not be built or installed.  We
    # have to do this here due to the translated manpage sources being
    # created whether we want all of them or not.

    set(manpage_includes
        -I${CMAKE_CURRENT_BINARY_DIR}
        -I${CMAKE_CURRENT_SOURCE_DIR})
    if (lang)
      set(manpage "${CMAKE_CURRENT_BINARY_DIR}/translated/${lang}/${pagename}.${section}")
      set(manpage_path "${lang}/man${section}")
      set(manpage_includes
          -I${CMAKE_CURRENT_BINARY_DIR}/translated/${lang}
          ${manpage_includes})
    else (lang)
      set(lang "en")
      set(manpage "${CMAKE_CURRENT_BINARY_DIR}/${pagename}.${section}")
      set(manpage_path "man${section}")
    endif (lang)

    add_custom_command(OUTPUT ${manpage}
                       COMMAND ${SOELIM_EXECUTABLE}
                               ${manpage_includes}
                               < "${manpage_source_file}"
                               > "${manpage}"
                       DEPENDS "${manpage_source_file}"
                               ${common_dependencies}
                               ${CMAKE_CURRENT_BINARY_DIR}/config.man
                       VERBATIM)
    install(FILES "${manpage}"
            DESTINATION "${CMAKE_INSTALL_FULL_MANDIR}/${manpage_path}")

    set(manpages ${manpages} ${manpage})
    set(schroot-${lang} ${schroot-${lang}} ${manpage})
    list(FIND combined "schroot-${lang}" combined_exists)
    if (combined_exists EQUAL -1)
      set(combined ${combined} "schroot-${lang}")
    endif(combined_exists EQUAL -1)
  endif(pagename)
endforeach(manpage_source)

add_custom_target(manpages ALL DEPENDS ${manpages})

if(GROFFER_EXECUTABLE)
  foreach(manpage ${manpages})
    set(manpages_ps ${manpages_ps} "${manpage}.ps")
    add_custom_command(OUTPUT "${manpage}.ps"
                       COMMAND ${GROFFER_EXECUTABLE} -K utf8 --ps -man --to-stdout "${manpage}" > "${manpage}.ps"
                       DEPENDS "${manpage}" ${common_dependencies} ${CMAKE_CURRENT_BINARY_DIR}/config.man
                       VERBATIM)

    set(manpages_pdf ${manpages_pdf} "${manpage}.pdf")
    add_custom_command(OUTPUT "${manpage}.pdf"
                       COMMAND ${GROFFER_EXECUTABLE} -K utf8 --pdf -man --to-stdout "${manpage}" > "${manpage}.pdf"
                       DEPENDS "${manpage}" ${common_dependencies} ${CMAKE_CURRENT_BINARY_DIR}/config.man
                       VERBATIM)
  endforeach(manpage)

  add_custom_target(manpages-ps DEPENDS ${manpages_ps})
  add_custom_target(manpages-pdf DEPENDS ${manpages_pdf})

  file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/combined)
  foreach(combined_lang ${combined})
    list(SORT ${combined_lang})

    add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/combined/${combined_lang}.ps"
                       COMMAND ${GROFFER_EXECUTABLE} -K UTF8 -T ps -man --to-stdout ${${combined_lang}} > "${CMAKE_CURRENT_BINARY_DIR}/combined/${combined_lang}.ps"
                       DEPENDS ${${combined_lang}}
                       VERBATIM)
    set(combined_ps ${combined_ps} "${CMAKE_CURRENT_BINARY_DIR}/combined/${combined_lang}.ps")

    add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/combined/${combined_lang}.pdf"
                       COMMAND ${GROFFER_EXECUTABLE} -K UTF8 -T pdf -man --to-stdout ${${combined_lang}} > "${CMAKE_CURRENT_BINARY_DIR}/combined/${combined_lang}.pdf"
                       DEPENDS ${${combined_lang}}
                       VERBATIM)
    set(combined_pdf ${combined_pdf} "${CMAKE_CURRENT_BINARY_DIR}/combined/${combined_lang}.pdf")

  endforeach(combined_lang)

  add_custom_target(manpages-combined-ps DEPENDS ${combined_ps})
  add_custom_target(manpages-combined-pdf DEPENDS ${combined_pdf})

  add_custom_target(man-po-notify
                    COMMAND ${po4a_command}
                    COMMAND podebconf-report-po --call --withtranslators --noforce --podir=${CMAKE_CURRENT_SOURCE_DIR}/po)

endif(GROFFER_EXECUTABLE)

=== po/CMakeLists.txt ===
# Copyright © 2004-2013  Roger Leigh <rleigh@codelibre.net>
#
# schroot is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# schroot is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see
# <http://www.gnu.org/licenses/>.
#
#####################################################################

if(BUILD_NLS)

  set(domain schroot)
  set(xgettext_options --keyword=_ --keyword=N_ --from-code=UTF-8
      --boost --no-location)
  set(copyright_holder "Roger Leigh <rleigh@codelibre.net>")
  set(bug_address "Roger Leigh <rleigh@codelibre.net>")

  file(READ LINGUAS languages)
  string(REGEX REPLACE "\n" ";" languages "${languages}")
  foreach(lang ${languages})
    set(po_files ${po_files} "${CMAKE_CURRENT_SOURCE_DIR}/${lang}.po")
  endforeach(lang)

  file(READ ${CMAKE_CURRENT_SOURCE_DIR}/POTFILES.in potfiles)
  string(REGEX REPLACE "\n" ";" potfiles "${potfiles}")
  file(REMOVE ${CMAKE_CURRENT_BINARY_DIR}/POTFILES)
  foreach(file ${potfiles})
    set(translated_files ${translated_files} "${PROJECT_SOURCE_DIR}/${file}")
  endforeach(file ${potfiles})

  foreach(file ${translated_files})
    if(EXISTS ${CMAKE_CURRENT_BINARY_DIR}/POTFILES)
      file(APPEND ${CMAKE_CURRENT_BINARY_DIR}/POTFILES "${file}\n")
    else(EXISTS ${CMAKE_CURRENT_BINARY_DIR}/POTFILES)
      file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/POTFILES "${file}\n")
    endif(EXISTS ${CMAKE_CURRENT_BINARY_DIR}/POTFILES)
  endforeach(file ${translated_files})

  # xgettext creates schroot.pot
  if(GIT_RELEASE_ENABLE)
    # Always update potfile when dependencies change.  Don't change
    # the date in the pot file, since this dirties the source
    # directory, but do allow any other change.
    execute_process(COMMAND sh -c "grep '^\"POT-Creation-Date: ' '${CMAKE_CURRENT_SOURCE_DIR}/${domain}.pot' | sed -e 's;^\"POT-Creation-Date: \\(.*\\)\\\\n\";\\1;'"
                    OUTPUT_VARIABLE pot_date
                    RESULT_VARIABLE grep_pot_status
                    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR})
    string(REGEX REPLACE "\n" "" pot_date "${pot_date}")
    add_custom_command(OUTPUT "${CMAKE_CURRENT_SOURCE_DIR}/${domain}.pot"
                       COMMAND xgettext --default-domain=${domain} --add-comments=TRANSLATORS:
                         ${xgettext_options} --files-from "${CMAKE_CURRENT_BINARY_DIR}/POTFILES"
                         --copyright-holder=${copyright_holder}
                         --msgid-bugs-address=${bug_address}
                         -d "${domain}" -p "${CMAKE_CURRENT_SOURCE_DIR}"
                       COMMAND ${CMAKE_COMMAND} -E rename "${CMAKE_CURRENT_SOURCE_DIR}/${domain}.po" "${CMAKE_CURRENT_SOURCE_DIR}/${domain}.pot"
                       COMMAND sh -c "sed -i -e 's;^\"POT-Creation-Date: \\(.*\\)\\\\n\";\"POT-Creation-Date: ${pot_date}\\\\n\";' '${CMAKE_CURRENT_SOURCE_DIR}/${domain}.pot'"
                       DEPENDS ${translated_files}
                       VERBATIM)
    add_custom_target(update-pot DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/${domain}.pot")
  else(GIT_RELEASE_ENABLE)
    # Only update potfile manually
    add_custom_target(update-pot
                      COMMAND xgettext --default-domain=${domain} --add-comments=TRANSLATORS:
                        ${xgettext_options} --files-from "${CMAKE_CURRENT_BINARY_DIR}/POTFILES"
                        --copyright-holder=${copyright_holder}
                        --msgid-bugs-address=${bug_address}
                        -d "${domain}" -p "${CMAKE_CURRENT_SOURCE_DIR}"
                      COMMAND ${CMAKE_COMMAND} -E rename "${CMAKE_CURRENT_SOURCE_DIR}/${domain}.po" "${CMAKE_CURRENT_SOURCE_DIR}/${domain}.pot"
                      DEPENDS ${translated_files}
                      VERBATIM)
  endif(GIT_RELEASE_ENABLE)

  # msgmerge --update
  foreach(pofile ${po_files})
    add_custom_command(OUTPUT "${pofile}"
                       COMMAND msgmerge --update "${pofile}"
                         "${CMAKE_CURRENT_SOURCE_DIR}/${domain}.pot"
                       COMMAND touch "${pofile}"
                       DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/${domain}.pot"
                       VERBATIM)
  endforeach(pofile)
  add_custom_target(update-po DEPENDS ${po_files})

  # msgfmt
  foreach(lang ${languages})
    add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/${lang}.gmo"
                       COMMAND ${CMAKE_COMMAND} -E remove "${CMAKE_CURRENT_BINARY_DIR}/${lang}.gmo"
                       COMMAND msgfmt -c --statistics -o "${CMAKE_CURRENT_BINARY_DIR}/${lang}.gmo"
                         "${CMAKE_CURRENT_SOURCE_DIR}/${lang}.po"
                       COMMAND touch "${CMAKE_CURRENT_BINARY_DIR}/${lang}.gmo"
                       DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/${lang}.po"
                       VERBATIM)
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${lang}.gmo"
            DESTINATION "${SCHROOT_LOCALE_DIR}/${lang}/LC_MESSAGES"
            RENAME "${domain}.mo")
    set(gmo_files ${gmo_files} "${CMAKE_CURRENT_BINARY_DIR}/${lang}.gmo")
  endforeach(lang)

if(GIT_RELEASE_ENABLE)
  add_dependencies(git-release update-pot update-po)
endif(GIT_RELEASE_ENABLE)

  add_custom_target(update-gmo ALL DEPENDS ${gmo_files})

  add_custom_target(po-notify
                    COMMAND podebconf-report-po --call --withtranslators --noforce --podir=${CMAKE_CURRENT_SOURCE_DIR})

endif(BUILD_NLS)

=== sbuild/CMakeLists.txt ===
# Copyright © 2004-2013  Roger Leigh <rleigh@codelibre.net>
#
# schroot is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# schroot is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see
# <http://www.gnu.org/licenses/>.
#
#####################################################################

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/sbuild-config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/sbuild-config.h)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/sbuild.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/sbuild.pc @ONLY)

include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

set(public_generated_h_sources
    config.h)

if(BUILD_PAM)
  set(public_auth_pam_h_sources
      sbuild-auth-pam-conv.h
      sbuild-auth-pam-conv-tty.h
      sbuild-auth-pam.h
      sbuild-auth-pam-message.h)
  set(public_auth_pam_cc_sources
      sbuild-auth-pam-conv.cc
      sbuild-auth-pam-conv-tty.cc
      sbuild-auth-pam.cc
      sbuild-auth-pam-message.cc)
endif(BUILD_PAM)

if(BUILD_BLOCKDEV)
  set(public_blockdev_base_h_sources
      sbuild-chroot-block-device-base.h)
  set(public_blockdev_base_cc_sources
      sbuild-chroot-block-device-base.cc)
  set(public_blockdev_h_sources
      sbuild-chroot-block-device.h)
  set(public_blockdev_cc_sources
      sbuild-chroot-block-device.cc)
endif(BUILD_BLOCKDEV)

if(BUILD_LVMSNAP)
  set(public_blockdev_base_h_sources
      sbuild-chroot-block-device-base.h)
  set(public_blockdev_base_cc_sources
      sbuild-chroot-block-device-base.cc)
  set(public_lvmsnap_h_sources
      sbuild-chroot-lvm-snapshot.h)
  set(public_lvmsnap_cc_sources
      sbuild-chroot-lvm-snapshot.cc)
endif(BUILD_LVMSNAP)

if(BUILD_ZFSSNAP)
  set(public_zfssnap_h_sources
      sbuild-chroot-zfs-snapshot.h)
  set(public_zfssnap_cc_sources
      sbuild-chroot-zfs-snapshot.cc)
endif(BUILD_ZFSSNAP)

if(BUILD_BTRFSSNAP)
  set(public_btrfssnap_h_sources
      sbuild-chroot-btrfs-snapshot.h)
  set(public_btrfssnap_cc_sources
      sbuild-chroot-btrfs-snapshot.cc)
endif(BUILD_BTRFSSNAP)

if(BUILD_LOOPBACK)
  set(public_loopback_h_sources
      sbuild-chroot-loopback.h)
  set(public_loopback_cc_sources
      sbuild-chroot-loopback.cc)
endif(BUILD_LOOPBACK)

if(BUILD_UNION)
  set(public_union_h_sources
      sbuild-chroot-facet-union.h)
  set(public_union_cc_sources
      sbuild-chroot-facet-union.cc)
endif(BUILD_UNION)

set(public_h_sources
    sbuild-basic-keyfile.h
    sbuild-basic-keyfile.tcc
    sbuild-ctty.h
    sbuild-custom-error.h
    sbuild-environment.h
    sbuild-error.h
    sbuild-error.tcc
    sbuild-fdstream.h
    sbuild-feature.h
    sbuild-format-detail.h
    sbuild-i18n.h
    sbuild-keyfile-base.h
    sbuild-keyfile.h
    sbuild-lock.h
    sbuild-log.h
    sbuild-mntstream.h
    sbuild-nostream.h
    sbuild-null.h
    sbuild-parse-error.h
    sbuild-parse-value.h
    sbuild-personality.h
    sbuild-regex.h
    sbuild-run-parts.h
    sbuild-session.h
    sbuild-tr1types.h
    sbuild-types.h
    sbuild-util.h)

set(public_cc_sources
    sbuild-ctty.cc
    sbuild-environment.cc
    sbuild-feature.cc
    sbuild-format-detail.cc
    sbuild-keyfile-base.cc
    sbuild-lock.cc
    sbuild-log.cc
    sbuild-mntstream.cc
    sbuild-nostream.cc
    sbuild-null.cc
    sbuild-parse-value.cc
    sbuild-personality.cc
    sbuild-run-parts.cc
    sbuild-session.cc
    sbuild-types.cc
    sbuild-util.cc)

set(public_auth_h_sources
    sbuild-auth.h
    sbuild-auth-null.h
    ${public_auth_pam_h_sources})

set(public_auth_cc_sources
    sbuild-auth.cc
    sbuild-auth-null.cc
    ${public_auth_pam_cc_sources})

set(public_chroot_h_sources
    sbuild-chroot.h
    sbuild-chroot-config.h
    sbuild-chroot-custom.h
    sbuild-chroot-directory.h
    sbuild-chroot-directory-base.h
    sbuild-chroot-file.h
    sbuild-chroot-plain.h
    ${public_blockdev_base_h_sources}
    ${public_blockdev_h_sources}
    ${public_lvmsnap_h_sources}
    ${public_zfssnap_h_sources}
    ${public_btrfssnap_h_sources}
    ${public_loopback_h_sources})

set(public_chroot_cc_sources
    sbuild-chroot.cc
    sbuild-chroot-config.cc
    sbuild-chroot-custom.cc
    sbuild-chroot-directory.cc
    sbuild-chroot-directory-base.cc
    sbuild-chroot-file.cc
    sbuild-chroot-plain.cc
    ${public_blockdev_base_cc_sources}
    ${public_blockdev_cc_sources}
    ${public_lvmsnap_cc_sources}
    ${public_zfssnap_cc_sources}
    ${public_btrfssnap_cc_sources}
    ${public_loopback_cc_sources})

set(public_chroot_facet_h_sources
    sbuild-chroot-facet.h
    sbuild-chroot-facet-mountable.h
    sbuild-chroot-facet-personality.h
    sbuild-chroot-facet-session.h
    sbuild-chroot-facet-session-clonable.h
    sbuild-chroot-facet-source.h
    sbuild-chroot-facet-source-clonable.h
    sbuild-chroot-facet-userdata.h
    ${public_union_h_sources}
    ${public_unshare_h_sources})

set(public_chroot_facet_cc_sources
    sbuild-chroot-facet-mountable.cc
    sbuild-chroot-facet-personality.cc
    sbuild-chroot-facet-session.cc
    sbuild-chroot-facet-session-clonable.cc
    sbuild-chroot-facet-source.cc
    sbuild-chroot-facet-source-clonable.cc
    sbuild-chroot-facet-userdata.cc
    ${public_union_cc_sources}
    ${public_unshare_cc_sources})

add_library(sbuild STATIC
            ${public_h_sources}
            ${public_cc_sources}
            ${public_auth_h_sources}
            ${public_auth_cc_sources}
            ${public_chroot_h_sources}
            ${public_chroot_cc_sources}
            ${public_chroot_facet_h_sources}
            ${public_chroot_facet_cc_sources})
target_link_libraries(sbuild
                      PRIVATE
                        ${CMAKE_THREAD_LIBS_INIT}
                        ${PAM_LIBRARY}
                        ${UUID_LIBRARY}
                        ${REGEX_LIBRARY}
                        ${Boost_IOSTREAMS_LIBRARY_RELEASE}
                        ${Boost_FILESYSTEM_LIBRARY_RELEASE}
                        ${Boost_SYSTEM_LIBRARY_RELEASE})

set(pkgincludedir "${CMAKE_INSTALL_FULL_INCLUDEDIR}/sbuild")
set(pkgincludeauthdir "${CMAKE_INSTALL_FULL_INCLUDEDIR}/sbuild")
set(pkgincludechrootdir "${CMAKE_INSTALL_FULL_INCLUDEDIR}/sbuild")
set(pkgincludechrootfacetdir "${CMAKE_INSTALL_FULL_INCLUDEDIR}/sbuild")
set(pkgconfigdatadir "${CMAKE_INSTALL_FULL_LIBDIR}/pkgconfig")

install(FILES ${public_h_sources}
        DESTINATION ${pkgincludedir})
install(FILES ${public_auth_h_sources}
        DESTINATION ${pkgincludeauthdir})
install(FILES ${public_chroot_h_sources}
        DESTINATION ${pkgincludechrootdir})
install(FILES ${public_chroot_facet_h_sources}
        DESTINATION ${pkgincludechrootfacetdir})

install(TARGETS sbuild ARCHIVE
        DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR})

set(pkgconfig_files "${CMAKE_CURRENT_BINARY_DIR}/sbuild.pc")
install(FILES ${pkgconfig_files}
        DESTINATION ${pkgconfigdatadir})

=== test/CMakeLists.txt ===
# Copyright © 2004-2013  Roger Leigh <rleigh@codelibre.net>
#
# schroot is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# schroot is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see
# <http://www.gnu.org/licenses/>.
#
#####################################################################

include_directories(${PROJECT_SOURCE_DIR}/bin)

set(test_sources
    testmain.cc)

if (BUILD_TESTS)
  add_library(testmain STATIC ${test_sources})
  target_link_libraries(testmain sbuild ${CPPUNIT_LIBRARY} ${CMAKE_THREAD_LIBS_INIT})
endif (BUILD_TESTS)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/setup-test-data.cmake
               ${CMAKE_CURRENT_BINARY_DIR}/setup-test-data)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/cleanup-test-data.cmake
               ${CMAKE_CURRENT_BINARY_DIR}/cleanup-test-data)

if(BUILD_BLOCKDEV)
  set(sbuild_chroot_blockdev_sources
      sbuild-chroot-block-device.cc)
endif(BUILD_BLOCKDEV)

if(BUILD_LOOPBACK)
  set(sbuild_chroot_loopback_sources
      sbuild-chroot-loopback.cc)
endif(BUILD_LOOPBACK)

if(BUILD_LVMSNAP)
  set(sbuild_chroot_lvmsnap_sources
      sbuild-chroot-lvm-snapshot.cc)
endif(BUILD_LVMSNAP)

if(BUILD_ZFSSNAP)
  set(sbuild_chroot_zfssnap_sources
      sbuild-chroot-zfs-snapshot.cc)
endif(BUILD_ZFSSNAP)

if(BUILD_BTRFSSNAP)
  set(sbuild_chroot_btrfssnap_sources
      sbuild-chroot-btrfs-snapshot.cc)
endif(BUILD_BTRFSSNAP)

if(BUILD_PERSONALITY)
  set(sbuild_personality_sources
    sbuild-personality.cc)
endif(BUILD_PERSONALITY)

set(sbuild_chroot_chroot_sources
    test-sbuild-chroot.h
    sbuild-chroot-plain.cc
    sbuild-chroot-custom.cc
    sbuild-chroot-file.cc
    sbuild-chroot-directory.cc
    ${sbuild_chroot_blockdev_sources}
    ${sbuild_chroot_lvmsnap_sources}
    ${sbuild_chroot_zfssnap_sources}
    ${sbuild_chroot_btrfssnap_sources}
    ${sbuild_chroot_loopback_sources}
    sbuild-chroot-facet-userdata.cc)

if (BUILD_TESTS)
  add_test(NAME setup-test-data
           WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
           COMMAND ${CMAKE_CURRENT_BINARY_DIR}/setup-test-data)
endif (BUILD_TESTS)

if (BUILD_TESTS)
  add_executable(sbuild-chroot-chroot ${sbuild_chroot_chroot_sources})
  target_link_libraries(sbuild-chroot-chroot
                        sbuild
                        ${REGEX_LIBRARY}
                        testmain)
  add_test(sbuild-chroot-chroot sbuild-chroot-chroot)
endif (BUILD_TESTS)

set(sbuild_chroot_config_sources
    sbuild-chroot-config.cc)

if (BUILD_TESTS)
  add_executable(sbuild-chroot-config ${sbuild_chroot_config_sources})
  target_link_libraries(sbuild-chroot-config sbuild testmain)
  add_test(sbuild-chroot-config sbuild-chroot-config)
endif (BUILD_TESTS)

set(sbuild_standard_sources
    sbuild-environment.cc
    sbuild-log.cc
    sbuild-nostream.cc
    sbuild-parse-value.cc
    ${sbuild_personality_sources}
    sbuild-regex.cc
    sbuild-util.cc)

if (BUILD_TESTS)
  add_executable(sbuild-standard ${sbuild_standard_sources})
  target_link_libraries(sbuild-standard
                        sbuild
                        ${REGEX_LIBRARY}
                        testmain)
  add_test(sbuild-standard sbuild-standard)
endif (BUILD_TESTS)

set(sbuild_keyfile_sources
    sbuild-keyfile.cc)

if (BUILD_TESTS)
  add_executable(sbuild-keyfile ${sbuild_keyfile_sources})
  target_link_libraries(sbuild-keyfile sbuild testmain)
  add_test(sbuild-keyfile sbuild-keyfile)
endif (BUILD_TESTS)

set(sbuild_lock_sources
    sbuild-lock.cc)

if (BUILD_TESTS)
  add_executable(sbuild-lock ${sbuild_lock_sources})
  target_link_libraries(sbuild-lock sbuild testmain)
  # lock is excluded, because it is timing dependent and can fail
  # randomly on slow or heavily-loaded systems.
endif (BUILD_TESTS)

set(sbuild_run_parts_sources
    sbuild-run-parts.cc)

if (BUILD_TESTS)
  add_executable(sbuild-run-parts ${sbuild_run_parts_sources})
  target_link_libraries(sbuild-run-parts
                        sbuild
                        ${Boost_FILESYSTEM_LIBRARY_RELEASE}
                        ${Boost_SYSTEM_LIBRARY_RELEASE}
                        testmain)
  add_test(sbuild-run-parts sbuild-run-parts)
endif (BUILD_TESTS)

set(schroot_base_option_action_sources
    schroot-base-option-action.cc)

if (BUILD_TESTS)
  add_executable(schroot-base-option-action ${schroot_base_option_action_sources})
  target_link_libraries(schroot-base-option-action schroot-base testmain)
  add_test(schroot-base-option-action schroot-base-option-action)
endif (BUILD_TESTS)

if (BUILD_TESTS)
  add_test(NAME cleanup-test-data
           WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
           COMMAND ${CMAKE_CURRENT_BINARY_DIR}/cleanup-test-data)
endif (BUILD_TESTS)

=== bin/dchroot-dsa/CMakeLists.txt ===
# Copyright © 2004-2013  Roger Leigh <rleigh@codelibre.net>
#
# schroot is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# schroot is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see
# <http://www.gnu.org/licenses/>.
#
#####################################################################

set(dchroot_dsa_sources
    dchroot-dsa-session.h
    dchroot-dsa-session.cc
    dchroot-dsa-options.h
    dchroot-dsa-options.cc
    dchroot-dsa-main.h
    dchroot-dsa-main.cc
    dchroot-dsa.cc)

include_directories(${PROJECT_BINARY_DIR}/bin ${PROJECT_SOURCE_DIR}/bin)

if(BUILD_DCHROOT_DSA)
  add_executable(dchroot-dsa ${dchroot_dsa_sources})
  target_link_libraries(dchroot-dsa sbuild schroot-base schroot-common dchroot-common)

  install(TARGETS dchroot-dsa RUNTIME
           DESTINATION ${CMAKE_INSTALL_FULL_BINDIR}
          PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE
                       GROUP_READ GROUP_EXECUTE
                      WORLD_READ WORLD_EXECUTE
                      SETUID)
endif(BUILD_DCHROOT_DSA)

=== bin/dchroot/CMakeLists.txt ===
# Copyright © 2004-2013  Roger Leigh <rleigh@codelibre.net>
#
# schroot is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# schroot is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see
# <http://www.gnu.org/licenses/>.
#
#####################################################################

set(dchroot_common_sources
    dchroot-main-base.h
    dchroot-main-base.cc
    dchroot-session-base.h
    dchroot-session-base.cc)

if (BUILD_LIBDCHROOT)
  add_library(dchroot-common STATIC ${dchroot_common_sources})
endif (BUILD_LIBDCHROOT)

set(dchroot_sources
    dchroot-session.h
    dchroot-session.cc
    dchroot-options.h
    dchroot-options.cc
    dchroot-main.h
    dchroot-main.cc
    dchroot.cc)

include_directories(${PROJECT_BINARY_DIR}/bin ${PROJECT_SOURCE_DIR}/bin)

if(BUILD_DCHROOT)
  add_executable(dchroot ${dchroot_sources})
  target_link_libraries(dchroot sbuild schroot-base schroot-common dchroot-common)

  install(TARGETS dchroot RUNTIME
          DESTINATION ${CMAKE_INSTALL_FULL_BINDIR}
          PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE
                       GROUP_READ GROUP_EXECUTE
                      WORLD_READ WORLD_EXECUTE
                      SETUID)
endif(BUILD_DCHROOT)

=== bin/schroot-base/CMakeLists.txt ===
# Copyright © 2004-2013  Roger Leigh <rleigh@codelibre.net>
#
# schroot is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# schroot is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see
# <http://www.gnu.org/licenses/>.
#
#####################################################################

set(schroot_base_sources
    schroot-base-main.h
    schroot-base-main.cc
    schroot-base-option-action.h
    schroot-base-option-action.cc
    schroot-base-options.h
    schroot-base-options.cc
    schroot-base-run.h)

add_library(schroot-base STATIC ${schroot_base_sources})
target_link_libraries(schroot-base sbuild ${Boost_PROGRAM_OPTIONS_LIBRARY_RELEASE})

=== bin/schroot-listmounts/CMakeLists.txt ===
# Copyright © 2004-2013  Roger Leigh <rleigh@codelibre.net>
#
# schroot is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# schroot is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see
# <http://www.gnu.org/licenses/>.
#
#####################################################################

set(listmounts_sources
    schroot-listmounts-main.h
    schroot-listmounts-main.cc
    schroot-listmounts-options.h
    schroot-listmounts-options.cc
    schroot-listmounts.cc)

add_executable(schroot-listmounts ${listmounts_sources})
target_link_libraries(schroot-listmounts sbuild schroot-base)

install(TARGETS schroot-listmounts RUNTIME
        DESTINATION ${SCHROOT_LIBEXEC_DIR})

=== debian/changelog ===
schroot (1.6.13-7build1) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 11 Aug 2025 08:29:04 +0200

schroot (1.6.13-7) unstable; urgency=medium

  * Team upload, debian salsa namespace.
  * Add Build-Depends: mount (Closes: #1104692)

 -- Chris Hofstaedtler <zeha@debian.org>  Sun, 04 May 2025 22:07:03 +0200

schroot (1.6.13-6) unstable; urgency=low

  * Support building schroot without root. Closes: #1089426
    Thanks Niels Thykier.
  * Add pt, pt_BR and ro debconf translation.
    Closes: #1025988, #1028228, #1033713
    Thanks to the respective submitters.

 -- Christoph Biedl <debian.axhn@manchmal.in-ulm.de>  Sun, 22 Dec 2024 21:28:39 +0100

schroot (1.6.13-5) unstable; urgency=low

  * Update dependencies on obsolete packages
  * Add proposed patches to fix regressions in 1.6.13-4, thanks
    Simon McVittie. Closes: #1078539, #1079124

 -- Christoph Biedl <debian.axhn@manchmal.in-ulm.de>  Fri, 30 Aug 2024 08:32:21 +0200

schroot (1.6.13-4) unstable; urgency=medium

  * Drop duplicates in buildd configuration
  * Add French debconf translation. Closes: #1020963
  * Add Dutch debconf translation. Closes: #1021446
  * Fix example configuration. Closes: #1021780
  * Document a login shell might be switched to a regular shell
  * Cherry-pick fix for build failure with GCC-14. Closes: #1075493
  * Cherry-pick "Mount a new instance of /dev/pts in the chroot".
    Closes: #856877, #983423

 -- Christoph Biedl <debian.axhn@manchmal.in-ulm.de>  Sat, 10 Aug 2024 15:23:12 +0200

schroot (1.6.13-3) unstable; urgency=medium

  * Add Spanish debconf translation. Closes: #1019483
  * Update French translation. Closes: #1020255
  * Cherry-pick "copyfiles: Replace dangling symlink during cp".
    Closes: #1020277
  * Cherry-pick copyfiles improvement from the 1.7 development branch
  * Fix variable usage in copyfiles copy_file() function

 -- Christoph Biedl <debian.axhn@manchmal.in-ulm.de>  Sun, 25 Sep 2022 20:34:42 +0200

schroot (1.6.13-2) unstable; urgency=medium

  * Add German debconf translation. Closes: #1017943
  * Cherry-pick "Replace usage of egrep and which". Closes: #1019295
  * Cherry-pick "Clean up mess created in the Portuguese
    translations". Closes: #965348 for real.

 -- Christoph Biedl <debian.axhn@manchmal.in-ulm.de>  Fri, 09 Sep 2022 19:14:33 +0200

schroot (1.6.13-1) unstable; urgency=medium

  * New upstream version 1.6.13

 -- Christoph Biedl <debian.axhn@manchmal.in-ulm.de>  Mon, 15 Aug 2022 20:54:58 +0200

schroot (1.6.12-2) unstable; urgency=high

  * Have stricter rules on chroot names. [CVE-2022-2787]

 -- Christoph Biedl <debian.axhn@manchmal.in-ulm.de>  Thu, 11 Aug 2022 21:04:10 +0200

schroot (1.6.12-1) unstable; urgency=low

  * New upstream, new upstream version
  * Ship script to sync the apt-cache between the host and chroot.
    Closes: #764785

 -- Christoph Biedl <debian.axhn@manchmal.in-ulm.de>  Fri, 22 Jul 2022 10:05:47 +0200

schroot (1.6.10-16) unstable; urgency=medium

  * Fix installation path of the service file/init script helper.
    Closes: #1012641

 -- Christoph Biedl <debian.axhn@manchmal.in-ulm.de>  Sat, 11 Jun 2022 08:33:27 +0200

schroot (1.6.10-15) unstable; urgency=medium

  * Fix arch-indep build (Closes: #1012609)

 -- Jakob Haufe <sur5r@debian.org>  Fri, 10 Jun 2022 11:29:31 +0200

schroot (1.6.10-14) unstable; urgency=medium

  * Support zstd compression for file based chroots. Closes: #988274
  * Provide a proper systemd service file. Closes: #865110
  * Update Portuguese translation. Closes: #965348
  * PAM: Use common-session-noninteractive. Closes: #898949

 -- Christoph Biedl <debian.axhn@manchmal.in-ulm.de>  Thu, 09 Jun 2022 07:53:36 +0200

schroot (1.6.10-13) unstable; urgency=low

  * Take maintainership. Closes: #900874
  * Streamline patch queue
  * Forward to latest commit in upstream repo, and refresh patches.
    Closes: #763896

 -- Christoph Biedl <debian.axhn@manchmal.in-ulm.de>  Sun, 29 May 2022 18:11:18 +0200

schroot (1.6.10-12) unstable; urgency=medium

  * QA upload.
  * ensure the parent directory for binfmt-misc interpreter
    for a foreign chroot exists before using it (Closes: #983087)

 -- Michael Tokarev <mjt@tls.msk.ru>  Sun, 28 Feb 2021 13:43:50 +0300

schroot (1.6.10-11) unstable; urgency=medium

  * QA upload.
  * Make the build reproducible:
    - Make the documentation build reproducibly. (Closes: #902804)
    - Specify reproducible=+fixfilepath to make the binaries reproducible.

 -- Chris Lamb <lamby@debian.org>  Thu, 24 Sep 2020 10:43:32 +0100

schroot (1.6.10-10) unstable; urgency=medium

  [ Alexis Murzeau ]
  * QA upload.
  * debian/control:
    + Remove Build-Depends on deprecated dh-systemd and depend on
      debhelper (>= 9.20160709) now that it integrates dh-systemd.
      Closes: #958621.

  [ Johannes 'josch' Schauer ]
  * add debian/salsa-ci.yml

 -- Johannes 'josch' Schauer <josch@debian.org>  Sun, 06 Sep 2020 16:33:58 +0200

schroot (1.6.10-9) unstable; urgency=medium

  * QA upload.
  * Source-only rebuild to allow testing migration.
  * debian/control:
    + Bump Standards-Version to 4.5.0.
    + Mark package schroot-common as Multi-Arch: foreign.

 -- Boyuan Yang <byang@debian.org>  Tue, 21 Jan 2020 12:32:05 -0500

schroot (1.6.10-8) unstable; urgency=medium

  * QA upload.
  * Fix install target to call install-arch instead of bypassing the
    various overrides (such as setting the binary suid root, and calling
    the test suite).  Closes: #948119.
  * debian/patches/zfs-snapshot-support.patch: fix the tests to match the
    implementation, overlooked due to the previous bug preventing the
    testsuite from being run during local test builds.

 -- Steve Langasek <vorlon@debian.org>  Sun, 05 Jan 2020 05:36:58 +0000

schroot (1.6.10-7) unstable; urgency=medium

  * QA upload.
  * debian/patches/zfs-snapshot-support.patch: add support for a zfs-
    snapshot backend.  Closes: #947919.


=== debian/control ===
Source: schroot
Maintainer: Christoph Biedl <debian.axhn@manchmal.in-ulm.de>
Uploaders:
    Jakob Haufe <sur5r@debian.org>,
Homepage: https://codeberg.org/shelter/reschroot
Rules-Requires-Root: no
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/debian/schroot
Vcs-Git: https://salsa.debian.org/debian/schroot.git
Build-Depends: debhelper-compat (= 13),
    bash-completion,
    cmake,
    fakeroot <!nocheck>,
    gettext,
    groff-base,
    libboost-dev,
    libboost-filesystem-dev,
    libboost-iostreams-dev,
    libboost-program-options-dev,
    libboost-regex-dev,
    libcppunit-dev,
    libpam0g-dev,
    mount,
    pkgconf,
    po4a,
    po-debconf,
    uuid-dev [!kfreebsd-any],
Priority: optional
Section: admin

Package: schroot-common
Architecture: all
Depends: ${misc:Depends},
Multi-Arch: foreign
Description: common files for schroot
 schroot allows users to execute commands or interactive shells in
 different chroots.  Any number of named chroots may be created, and
 access permissions given to each, including root access for normal
 users, on a per-user or per-group basis.  Additionally, schroot can
 switch to a different user in the chroot, using PAM for
 authentication and authorisation.  All operations are logged for
 security.
 .
 This package provides translations for localisation of schroot
 programs.

Package: schroot
Architecture: any
Pre-Depends:
    debconf,
Depends: ${misc:Depends}, ${shlibs:Depends},
    schroot-common (= ${source:Version}),
    sysvinit-utils,
Suggests:
    aufs-tools | unionfs-fuse,
    btrfs-progs,
    bzip2,
    debootstrap,
    lvm2,
    qemu-user-static,
    xz-utils,
    zfsutils-linux,
    zstd,
Enhances:
    sbuild,
Description: Execute commands in a chroot environment
 schroot allows users to execute commands or interactive shells in
 different chroots.  Any number of named chroots may be created, and
 access permissions given to each, including root access for normal
 users, on a per-user or per-group basis.  Additionally, schroot can
 switch to a different user in the chroot, using PAM for
 authentication and authorisation.  All operations are logged for
 security.
 .
 Several different types of chroot are supported, including normal
 directories in the filesystem, and also block devices.  Sessions,
 persistent chroots created on the fly from files (tar with optional
 compression) and Btrfs, ZFS, and LVM snapshots are also supported.
 .
 schroot supports kernel personalities, allowing the programs run
 inside the chroot to have a different personality.  For example,
 running 32-bit chroots on 64-bit systems, or even running binaries
 from alternative operating systems such as SVR4 or Xenix.
 .
 schroot also integrates with sbuild, to allow building packages with
 all supported chroot types, including session-managed chroot types
 such as Btrfs, ZFS, and LVM snapshots.
 .
 schroot shares most of its options with dchroot, but offers vastly
 more functionality.

=== debian/watch ===

version=4
opts="mode=git, gitmode=shallow, pgpmode=gittag" \
 https://codeberg.org/shelter/reschroot.git \
 refs/tags/release/reschroot-@ANY_VERSION@
